Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableRoleListView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableRoleListView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableRoleListView.Designer.cs	(revision 16044)
@@ -66,5 +66,5 @@
       // 
       this.storeButton.Enabled = false;
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(33, 3);
       this.storeButton.Name = "storeButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableRoleSelectionListView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableRoleSelectionListView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableRoleSelectionListView.Designer.cs	(revision 16044)
@@ -53,5 +53,5 @@
       // 
       this.storeButton.Enabled = false;
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(33, 3);
       this.storeButton.Name = "storeButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserGroupListView.Designer.cs	(revision 16044)
@@ -66,5 +66,5 @@
       // 
       this.storeButton.Enabled = false;
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(33, 3);
       this.storeButton.Name = "storeButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserListView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserListView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/RefreshableUserListView.Designer.cs	(revision 16044)
@@ -66,5 +66,5 @@
       this.storeButton.Enabled = false;
       this.storeButton.Location = new System.Drawing.Point(33, 3);
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Name = "storeButton";
       this.storeButton.Size = new System.Drawing.Size(24, 24);
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Administration/3.3/Views/UserGroupView.Designer.cs	(revision 16044)
@@ -108,5 +108,5 @@
       // 
       this.storeButton.Enabled = false;
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(31, 58);
       this.storeButton.Name = "storeButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Views/3.3/UserViews/RefreshableLightweightAccessClientInformationView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Views/3.3/UserViews/RefreshableLightweightAccessClientInformationView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Access.Views/3.3/UserViews/RefreshableLightweightAccessClientInformationView.Designer.cs	(revision 16044)
@@ -72,5 +72,5 @@
       // 
       this.storeButton.Enabled = false;
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(34, 3);
       this.storeButton.Name = "storeButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ScheduleView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ScheduleView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Administrator/3.3/Views/ScheduleView.Designer.cs	(revision 16044)
@@ -198,5 +198,5 @@
       // 
       this.btnSaveCal.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.btnSaveCal.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.btnSaveCal.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.btnSaveCal.ImageAlign = System.Drawing.ContentAlignment.MiddleLeft;
       this.btnSaveCal.Location = new System.Drawing.Point(640, 41);
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 16044)
@@ -139,4 +139,18 @@
           }
 
+          if (Content.Job != null && Content.Job.ProjectId == Guid.Empty) {
+            if (HiveClient.Instance != null && HiveClient.Instance.Projects != null && HiveClient.Instance.Projects.Count == 1) {
+              var p = HiveClient.Instance.Projects.FirstOrDefault();
+              if (p != null && p.Id != Guid.Empty) {
+                hiveResourceSelectorDialog = new HiveResourceSelectorDialog(Content.Job.Id, Content.Job.ProjectId);
+                Content.Job.ProjectId = p.Id;
+                Content.Job.ResourceIds = HiveClient.Instance.GetAvailableResourcesForProject(p.Id).Select(x => x.Id).ToList();
+                hiveResourceSelectorDialog.SelectedProjectId = Content.Job.ProjectId;
+                hiveResourceSelectorDialog.SelectedResourceIds = Content.Job.ResourceIds;
+              }                
+            }
+          }
+
+
           nameTextBox.Text = Content.Job.Name;
           descriptionTextBox.Text = Content.Job.Description;
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive.Views/3.3/HiveItemView.Designer.cs	(revision 16044)
@@ -52,5 +52,5 @@
       // storeButton
       // 
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(0, 0);
       this.storeButton.Name = "storeButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 16044)
@@ -319,4 +319,9 @@
       else return Enumerable.Empty<Resource>();
     }
+
+    public IEnumerable<Resource> GetAvailableResourcesForProject(Guid id) {
+      var assignedProjectResources = HiveServiceLocator.Instance.CallHiveService(s => s.GetAssignedResourcesForProject(id));
+      return resources.Where(x => assignedProjectResources.Select(y => y.ResourceId).Contains(x.Id));
+    }
     #endregion
 
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/AlgorithmView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/AlgorithmView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/AlgorithmView.Designer.cs	(revision 16044)
@@ -147,5 +147,5 @@
       // storeUsersButton
       // 
-      this.storeUsersButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeUsersButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeUsersButton.Location = new System.Drawing.Point(37, 9);
       this.storeUsersButton.Name = "storeUsersButton";
@@ -250,5 +250,5 @@
       // storeDataButton
       // 
-      this.storeDataButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeDataButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeDataButton.Location = new System.Drawing.Point(36, 6);
       this.storeDataButton.Name = "storeDataButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/OKBItemView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/OKBItemView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/OKBItemView.Designer.cs	(revision 16044)
@@ -52,5 +52,5 @@
       // storeButton
       // 
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(0, 0);
       this.storeButton.Name = "storeButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/ProblemView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/ProblemView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/Administration/Views/ProblemView.Designer.cs	(revision 16044)
@@ -147,5 +147,5 @@
       // storeUsersButton
       // 
-      this.storeUsersButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeUsersButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeUsersButton.Location = new System.Drawing.Point(38, 9);
       this.storeUsersButton.Name = "storeUsersButton";
@@ -249,5 +249,5 @@
       // storeDataButton
       // 
-      this.storeDataButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeDataButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeDataButton.Location = new System.Drawing.Point(36, 6);
       this.storeDataButton.Name = "storeDataButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/OKBProblemView.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/OKBProblemView.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/OKBProblemView.cs	(revision 16044)
@@ -72,9 +72,9 @@
       downloadCharacteristicsButton.Image = VSImageLibrary.Refresh;
       uploadCharacteristicsButton.Text = string.Empty;
-      uploadCharacteristicsButton.Image = VSImageLibrary.PublishToWeb;
+      uploadCharacteristicsButton.Image = VSImageLibrary.Save;
       refreshSolutionsButton.Text = string.Empty;
       refreshSolutionsButton.Image = VSImageLibrary.Refresh;
       uploadSolutionsButton.Text = string.Empty;
-      uploadSolutionsButton.Image = VSImageLibrary.PublishToWeb;
+      uploadSolutionsButton.Image = VSImageLibrary.Save;
     }
 
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/OKBRunView.Designer.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/OKBRunView.Designer.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/OKBRunView.Designer.cs	(revision 16044)
@@ -51,5 +51,5 @@
       // storeButton
       // 
-      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.PublishToWeb;
+      this.storeButton.Image = HeuristicLab.Common.Resources.VSImageLibrary.Save;
       this.storeButton.Location = new System.Drawing.Point(0, 0);
       this.storeButton.Name = "storeButton";
Index: /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.cs
===================================================================
--- /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.cs	(revision 16043)
+++ /branches/2839_HiveProjectManagement/HeuristicLab.Clients.OKB.Views/3.3/RunCreation/Views/SingleObjectiveOKBSolutionView.cs	(revision 16044)
@@ -41,5 +41,5 @@
       refreshButton.Image = VSImageLibrary.Refresh;
       uploadButton.Text = string.Empty;
-      uploadButton.Image = VSImageLibrary.PublishToWeb;
+      uploadButton.Image = VSImageLibrary.Save;
     }
 