Index: /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.Designer.cs
===================================================================
--- /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.Designer.cs	(revision 16046)
+++ /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.Designer.cs	(revision 16047)
@@ -54,4 +54,5 @@
       this.yAxisComboBox = new System.Windows.Forms.ComboBox();
       this.chart = new HeuristicLab.Visualization.ChartControlsExtensions.EnhancedChart();
+      this.openBubbleChartViewToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       this.noRunsLabel = new System.Windows.Forms.Label();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
@@ -112,6 +113,6 @@
       // chart
       // 
-      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       chartArea1.Name = "ChartArea1";
@@ -132,4 +133,11 @@
       this.chart.MouseMove += new System.Windows.Forms.MouseEventHandler(this.chart_MouseMove);
       // 
+      // openBubbleChartViewToolStripMenuItem
+      // 
+      this.openBubbleChartViewToolStripMenuItem.Name = "openBubbleChartViewToolStripMenuItem";
+      this.openBubbleChartViewToolStripMenuItem.Size = new System.Drawing.Size(256, 22);
+      this.openBubbleChartViewToolStripMenuItem.Text = "Open BubbleChart View";
+      this.openBubbleChartViewToolStripMenuItem.Click += new System.EventHandler(this.openBubbleChartViewToolStripMenuItem_Click);
+      // 
       // noRunsLabel
       // 
@@ -183,6 +191,6 @@
       // statisticsGroupBox
       // 
-      this.statisticsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.statisticsGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.statisticsGroupBox.Controls.Add(this.statisticsMatrixView);
@@ -239,4 +247,5 @@
     private System.Windows.Forms.ToolTip tooltip;
     protected System.Windows.Forms.CheckBox showStatisticsCheckBox;
+    private System.Windows.Forms.ToolStripMenuItem openBubbleChartViewToolStripMenuItem;
   }
 }
Index: /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs
===================================================================
--- /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs	(revision 16046)
+++ /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBoxPlotView.cs	(revision 16047)
@@ -48,4 +48,6 @@
     public RunCollectionBoxPlotView() {
       InitializeComponent();
+      chart.ContextMenuStrip.Items.Insert(0, openBubbleChartViewToolStripMenuItem);
+
       categoricalMapping = new Dictionary<int, Dictionary<object, double>>();
       seriesCache = new SortedDictionary<double, Series>();
@@ -211,5 +213,5 @@
 
     private void UpdateStatistics() {
-      DoubleMatrix matrix = new DoubleMatrix(9, seriesCache.Count);
+      DoubleMatrix matrix = new DoubleMatrix(10, seriesCache.Count);
       matrix.SortableView = false;
       List<string> columnNames = new List<string>();
@@ -224,5 +226,6 @@
             AxisDimension axisDimension = (AxisDimension)Enum.Parse(typeof(AxisDimension), selectedAxis);
             switch (axisDimension) {
-              case AxisDimension.Color: value = new StringValue(run.Color.ToString());
+              case AxisDimension.Color:
+                value = new StringValue(run.Color.ToString());
                 break;
             }
@@ -236,5 +239,5 @@
       }
       matrix.ColumnNames = columnNames;
-      matrix.RowNames = new string[] { "Count", "Minimum", "Maximum", "Median", "Average", "Standard Deviation", "Variance", "25th Percentile", "75th Percentile" };
+      matrix.RowNames = new string[] { "Count", "Minimum", "Maximum", "Median", "Average", "Standard Deviation", "Variance", "25th Percentile", "75th Percentile", "Interquartile Range" };
 
       for (int i = 0; i < seriesCache.Count; i++) {
@@ -250,4 +253,5 @@
         matrix[7, i] = seriesValues.Quantile(0.25);
         matrix[8, i] = seriesValues.Quantile(0.75);
+        matrix[9, i] = matrix[8, i] - matrix[7, i];
       }
       statisticsMatrixView.Content = matrix;
@@ -445,4 +449,12 @@
     }
 
+    private void openBubbleChartViewToolStripMenuItem_Click(object sender, EventArgs e) {
+      RunCollectionBubbleChartView bubbleChartView = new RunCollectionBubbleChartView();
+      bubbleChartView.Content = this.Content;
+      bubbleChartView.xAxisComboBox.SelectedItem = xAxisComboBox.SelectedItem;
+      bubbleChartView.yAxisComboBox.SelectedItem = yAxisComboBox.SelectedItem;
+      bubbleChartView.Show();
+    }
+
     private void chart_MouseMove(object sender, MouseEventArgs e) {
       string newTooltipText = string.Empty;
@@ -463,9 +475,9 @@
     }
 
-	public bool StatisticsVisible {
-		get { return splitContainer.Panel2Collapsed; }
-		set { splitContainer.Panel2Collapsed = value; }
-	}
-	
+    public bool StatisticsVisible {
+      get { return splitContainer.Panel2Collapsed; }
+      set { splitContainer.Panel2Collapsed = value; }
+    }
+
     public void SetXAxis(string axisName) {
       xAxisComboBox.SelectedItem = axisName;
Index: /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs
===================================================================
--- /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs	(revision 16046)
+++ /stable/HeuristicLab.Optimization.Views/3.3/RunCollectionViews/RunCollectionBubbleChartView.Designer.cs	(revision 16047)
@@ -201,6 +201,6 @@
       // chart
       // 
-      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.chart.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       chartArea1.Name = "ChartArea1";
@@ -455,7 +455,7 @@
 
     private System.Windows.Forms.Label xAxisLabel;
-    private System.Windows.Forms.ComboBox xAxisComboBox;
+    internal System.Windows.Forms.ComboBox xAxisComboBox;
     private System.Windows.Forms.Label yAxisLabel;
-    private System.Windows.Forms.ComboBox yAxisComboBox;
+    internal System.Windows.Forms.ComboBox yAxisComboBox;
     private System.Windows.Forms.TrackBar yTrackBar;
     private System.Windows.Forms.TrackBar xTrackBar;